#!/usr/bin/env python

# Inspire by Conbagui tutorial found here: http://fav.me/d91g0n9

# author: Pocholo
# date: 6/24/20

# Comments directed to http://gimpchat.com

# It create a 1600 X 712 yummy Caramel or a Chocolate text effect. Do not eat the text, please!
# Installation:
# This script should be placed in the user plugin folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.


from gimpfu import *

def pm_caramel_or_chocolate_text(img, draw, customtext, font, caramel, chocolate):

	#Set Undo Start
	pdb.gimp_image_undo_group_start(img)
	
	#Initiates the temporary state
	pdb.gimp_context_push()
	
	
	#Variables
	Width = img.width
	Height = img.height
	
	pdb.gimp_image_remove_layer(img, draw)
	
	if caramel:
		#Create the text
		pdb.gimp_context_set_foreground((32, 18, 0))
		layer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 90, 
											TRUE, 500, PIXELS, font)
		pdb.gimp_text_layer_set_justification(layer, 2)
		


		#Resize image
		img.resize(layer.width, layer.height, 0, 0)
		
		#Create a text copy
		non_empty = pdb.gimp_edit_copy(layer)
		copyLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Caramel copy", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, copyLayer, 0)
		pdb.gimp_layer_add_alpha(copyLayer)
		pdb.gimp_drawable_fill(copyLayer, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(copyLayer, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
		pdb.gimp_item_set_visible(copyLayer, FALSE)
		pdb.gimp_image_set_active_layer(img, layer)
		
			
		#Create background
		backlayer = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backlayer, 2)
		pdb.gimp_context_set_foreground((18, 6, 0))
		pdb.gimp_drawable_fill(backlayer, FILL_FOREGROUND)	
		
		#Create gradient for the background
		pdb.gimp_context_set_foreground((169, 117, 55))
		pdb.gimp_edit_blend(backlayer, 2, LAYER_MODE_NORMAL, 2, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 800, 0, 800, 800)
		pdb.gimp_context_set_foreground((217, 185, 151))
		pdb.gimp_edit_blend(backlayer, 2, LAYER_MODE_NORMAL, 2, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 800, 0, 800, 600)
		pdb.plug_in_gauss_rle2(img, backlayer, 400, 400)
		
		#Create the effect 
		 
		#Drop Shadow
		pdb.python_layerfx_drop_shadow(img, layer, 
										(0, 0, 0),   #color
											   75,   #opacity
												0,   #contou-linear
												0,   #noise 
												3,   #mode for multiply 
												0,   #spread 
											   14,   #size 
											  130,   #offset_angle 
												10,   #offset_distance 
											 TRUE,   #knockout 
											FALSE)   #merge
		
		#Bevel and Emboss
		pdb.python_layerfx_bevel_emboss(img, layer, 
												 1,   #style inner bevel
												65,   #depth 
												 0,   #direction 
												10,   #size 
												16,   #soften
											   130,   #angle 
												35,   #altitude 
												 3,   #gloss_contour- gaussian 
								   (252, 207, 145),   #highlight_color 
												 4,   #highlight_mode lighten only
												55,   #highlight_opacity
										   "Black",   #shadow_color 
												 3,   #shadow_mode multyply
											   100,   #shadow_opacity 
												 6,   #surface_contour-half round 
											 FALSE,   #use_texture 
										"3D Green",   #pattern 
											   100,   #scale 
											   100,   #tex_depth 
											  TRUE,   #invert 
											 FALSE)   #merge

		#Color Overlay
		pdb.python_layerfx_color_overlay(img, layer, 
									   (152, 95, 0),  #color
												100,  #opacity
												  0,  #mode normal
											  FALSE)  #merge

		
		#Bevel and Emboss for the text copy
		pdb.gimp_image_set_active_layer(img, copyLayer)
		pdb.python_layerfx_bevel_emboss(img, copyLayer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													20,   #size 
													16,   #soften
												   130,   #angle 
													35,   #altitude 
													 3,   #gloss_contour- gaussian 
									   (252, 207, 145),   #highlight_color 
													 4,   #highlight_mode lighten only
													55,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode multyply
												   100,   #shadow_opacity 
													 6,   #surface_contour-half round 
												 FALSE,   #use_texture 
											"3D Green",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												 FALSE)   #merge
											 
		
		#Gradient Overlay
		pdb.gimp_context_set_foreground((180, 113, 17))
		pdb.gimp_context_set_background((111, 66, 0))
		pdb.python_layerfx_gradient_overlay(img, copyLayer, 
										  "FG to BG (RGB)",   #gradient 
														 0,   #gradient_type linear 
														 0,   #repeat none 
													 FALSE,   #reverse 
														85,   #opacity 
														21,   #mode grain merge 
													   800,   #center_x 
													   450,   #center_y 
														90,   #angle 
													   200,   #width 
													 FALSE)   #merge
													 
		
		pdb.gimp_image_remove_layer(img, copyLayer)
		pdb.gimp_item_set_visible(backlayer, FALSE)											 
		layer = pdb.gimp_image_merge_visible_layers(img, 2)
		pdb.gimp_item_set_name(layer, "Caramel")
		pdb.gimp_layer_resize_to_image_size(layer)
		pdb.gimp_item_set_visible(backlayer, TRUE)		


	#Chocolate Text
	if chocolate:
		#Create the text
		pdb.gimp_context_set_foreground((12, 7, 0))
		layer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 70, 
											TRUE, 475, PIXELS, font)
		pdb.gimp_text_layer_set_justification(layer, 2)

		#Resize image
		img.resize(layer.width, layer.height, 0, 0)
		
		#Create a text copy
		non_empty = pdb.gimp_edit_copy(layer)
		copyLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Caramel copy", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, copyLayer, 0)
		pdb.gimp_layer_add_alpha(copyLayer)
		pdb.gimp_drawable_fill(copyLayer, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(copyLayer, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
		pdb.gimp_item_set_visible(copyLayer, FALSE)
		pdb.gimp_image_set_active_layer(img, layer)
		
			
		#Create background
		backlayer = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backlayer, 2)
		pdb.gimp_context_set_foreground((7, 4, 0))
		pdb.gimp_drawable_fill(backlayer, FILL_FOREGROUND)	
		
		#Create gradient for the background
		pdb.gimp_context_set_foreground((67, 34, 19))
		pdb.gimp_edit_blend(backlayer, 2, LAYER_MODE_NORMAL, 2, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 800, 0, 800, 800)
		pdb.gimp_context_set_foreground((136, 83, 59))
		pdb.gimp_edit_blend(backlayer, 2, LAYER_MODE_NORMAL, 2, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 800, 0, 800, 800)
		pdb.plug_in_gauss_rle2(img, backlayer, 400, 400)
		
		#Create the effect 
		pdb.gimp_image_set_active_layer(img, layer) 
		
		#Drop Shadow
		pdb.python_layerfx_drop_shadow(img, layer, 
										(0, 0, 0),   #color
											 0.75,   #opacity
												0,   #contou-linear
												0,   #noise 
												3,   #mode for multiply 
												0,   #spread 
											   10,   #size 
											  130,   #offset_angle 
											   14,   #offset_distance 
											 TRUE,   #knockout 
											FALSE)   #merge
		
		#Bevel and Emboss 		
		pdb.python_layerfx_bevel_emboss(img, layer, 
												 1,   #style inner bevel
												65,   #depth 
												 0,   #direction 
												10,   #size 
												16,   #soften
											   130,   #angle 
												35,   #altitude 
												 3,   #gloss_contour- gaussian 
								   (252, 207, 145),   #highlight_color 
												 4,   #highlight_mode lighten only
												55,   #highlight_opacity
										   "Black",   #shadow_color 
												 3,   #shadow_mode multyply
											   100,   #shadow_opacity 
												 6,   #surface_contour-half round 
											 FALSE,   #use_texture 
										"3D Green",   #pattern 
											   100,   #scale 
											   100,   #tex_depth 
											  TRUE,   #invert 
											 FALSE)   #merge

		#Bevel and Emboss for the text copy
		pdb.gimp_image_set_active_layer(img, copyLayer)
		pdb.python_layerfx_bevel_emboss(img, copyLayer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													20,   #size 
													16,   #soften
												   130,   #angle 
													35,   #altitude 
													 3,   #gloss_contour- gaussian 
									   (252, 207, 145),   #highlight_color 
													 4,   #highlight_mode lighten only
													55,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode multyply
												   100,   #shadow_opacity 
													 6,   #surface_contour-half round 
												 FALSE,   #use_texture 
											"3D Green",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												 FALSE)   #merge
											 
		#Gradient Overlay
		pdb.gimp_context_set_foreground((180, 113, 17))
		pdb.gimp_context_set_background((111, 66, 0))
		pdb.python_layerfx_gradient_overlay(img, copyLayer, 
										  "FG to BG (RGB)",   #gradient 
														 0,   #gradient_type linear 
														 0,   #repeat none 
													 FALSE,   #reverse 
														85,   #opacity 
														21,   #mode grain merge 
													   800,   #center_x 
													   450,   #center_y 
														90,   #angle 
													   200,   #width 
													 FALSE)   #merge
													 
		pdb.gimp_image_remove_layer(img, copyLayer)
		pdb.gimp_item_set_visible(backlayer, FALSE)											 
		layer = pdb.gimp_image_merge_visible_layers(img, 2)
		pdb.gimp_item_set_name(layer, "Chocolate")
		pdb.gimp_layer_resize_to_image_size(layer)
		pdb.gimp_item_set_visible(backlayer, TRUE)		

	#Set Undo End
	pdb.gimp_image_undo_group_end(img)
	pdb.gimp_context_pop()

register(
	"pm_caramel_or_chocolate_text",
	"Creates a tasty Caramel or chocolate text",
	"Creates a tasty Caramel or chocolate text",
	"Pocholo",
	"Pocholo",
	"2020",
	"Caramel or Chocolate text",
	"RGB*",
[
	(PF_IMAGE, "img", "Input image", None),
	(PF_DRAWABLE, "draw", "Input drawable", None),
	(PF_STRING, "customtext", "Text string", 'Caramel'),
    (PF_FONT, "font", "Font face", "ArTarumianGovazd Italic"),
	(PF_BOOL, "caramel", "Caramel Text", False),
    (PF_BOOL, "chocolate", "Chocolate Text", False),
],
[],
pm_caramel_or_chocolate_text, menu="<Image>/Pocholo-scripts/Caramel or Chocolate text")
main()